///////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2011 Cinterion Wireless Modules GmbH
//
// This software is protected by international intellectual property laws and
// treaties.
// Cinterion Wireless Modules GmbH ("Cinterion") grants to customer a limited,
// non-exclusive, non-transferable, royalty-free license to use the source code
// as a sample implementation and for the purpose of evaluation, analysis and
// to provide feedback thereon to Cinterion. Any right, title and interest in
// and to the source code, other than those expressly granted to the customer
// under this agreement, shall remain vested with Cinterion. This license may
// be terminated by Cinterion at any time in writing. Customer undertakes not
// to provide third parties with the source code. In particular, Customer is
// not allowed to sell the source code.
// The information contained in this document is considered the CONFIDENTIAL
// and PROPRIETARY information of Cinterion Wireless Modules GmbH and may not
// be disclosed or discussed with anyone who is not employed by Cinterion
// Wireless Modules GmbH, unless the individual/ company:
//
// i)  has an express need to know such information, and
//
// ii) disclosure of information is subject to the terms of a duly executed
//     Confidentiality and Non-Disclosure Agreement between Cinterion Wireless
//     Modules GmbH and the individual / company.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// CINTERION, ITS LEGAL REPRESENTATIVES AND VICARIOUS AGENTS SHALL 
// IRRESPECTIVE OF THE LEGAL GROUND  ONLY BE LIABLE FOR DAMAGES IF THE DAMAGE
// WAS CAUSED THROUGH CULPABLE BREACH OF A MAJOR CONTRACTUAL OBLIGATION
// (CARDINAL DUTY), I.E. A DUTY THE FULFILMENT OF WHICH ALLOWS THE PROPER
// EXECUTION OF THE RESPECTIVE AGREEMENT IN THE FIRST PLACE OR THE BREACH OF
// WHICH PUTS THE ACHIEVEMENT OF THE PURPOSE OF THE AGREEMENT AT STAKE,
// RESPECTIVELY, AND ON THE FULFILMENT OF WHICH THE RECIPIENT THEREFORE MAY
// RELY ON OR WAS CAUSED BY GROSS NEGLIGENCE OR INTENTIONALLY. ANY FURTHER
// LIABILITY FOR DAMAGES SHALL  IRRESPECTIVE OF THE LEGAL GROUND  BE
// EXCLUDED. IN THE EVENT THAT CINTERION IS LIABLE FOR THE VIOLATION OF A MAJOR
// CONTRACTUAL OBLIGATION IN THE ABSENCE OF GROSS NEGLIGENCE OR WILFUL CONDUCT,
// SUCH LIABILITY FOR DAMAGE SHALL BE LIMITED TO AN EXTENT WHICH, AT THE TIME
// WHEN THE RESPECTIVE AGREEMENT IS CONCLUDED, CINTERION SHOULD NORMALLY EXPECT
// TO ARISE DUE TO CIRCUMSTANCES THAT THE PARTIES HAD KNOWLEDGE OF AT SUCH
// POINT IN TIME. CINTERION SHALL IN NO EVENT BE LIABLE FOR INDIRECT AND
// CONSEQUENTIAL DAMAGES OR LOSS OF PROFIT. CINTERION SHALL IN NO EVENT BE
// LIABLE FOR AN AMOUNT EXCEEDING  20,000.00 PER EVENT OF DAMAGE. WITHIN THE
// BUSINESS RELATIONSHIP THE OVERALL LIABILITY SHALL BE LIMITED TO A TOTAL OF
//  100,000.00. CLAIMS FOR DAMAGES SHALL BECOME TIME-BARRED AFTER ONE YEAR AS
// OF THE BEGINNING OF THE STATUTORY LIMITATION PERIOD. IRRESPECTIVE OF THE
// LICENSEES KNOWLEDGE OR GROSS NEGLIGENT LACK OF KNOWLEDGE OF THE
// CIRCUMSTANCES GIVING RISE FOR A LIABILITY ANY CLAIMS SHALL BECOME
// TIME-BARRED AFTER FIVE YEARS AS OF THE LIABILITY AROSE. THE AFOREMENTIONED
// LIMITATION OR EXCLUSION OF LIABILITY SHALL NOT APPLY IN THE CASE OF CULPABLE
// INJURY TO LIFE, BODY OR HEALTH, IN CASE OF INTENTIONAL ACTS, UNDER THE
// LIABILITY PROVISIONS OF THE GERMAN PRODUCT LIABILITY ACT
// (PRODUKTHAFTUNGSGESETZ) OR IN CASE OF A CONTRACTUALLY AGREED OBLIGATION TO
// ASSUME LIABILITY IRRESPECTIVE OF ANY FAULT (GUARANTEE).
//
// IN THE EVENT OF A CONFLICT BETWEEN THE PROVISIONS OF THIS AGREEMENT AND
// ANOTHER AGREEMENT REGARDING THE SOURCE CODE (EXCEPT THE GENERAL TERMS AND
// CONDITIONS OF CINTERION) THE OTHER AGREEMENT SHALL PREVAIL.
//
// All rights created by patent grant or registration of a utility model or
// design patent are reserved.
//
///////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "AboutDlg.h"
#include "VersionInfo.h"
#include "Resource.h"

#include <sstream>
#include <iomanip>


BEGIN_MESSAGE_MAP(AboutDlg, CDialog)
   //{{AFX_MSG_MAP(AboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



AboutDlg::AboutDlg() 
: CDialog(IDD_ABOUTBOX)
{
}

void AboutDlg::DoDataExchange
(
    CDataExchange* pDX
)
{
    CDialog::DoDataExchange(pDX);

    //{{AFX_DATA_MAP(AboutDlg)   
    DDX_Control(pDX, IDC_STATIC_VERSION,     m_wndProductVersion);
    DDX_Control(pDX, IDC_STATIC_COPYRIGHT,   m_wndLegalCopyright);
    DDX_Control(pDX, IDC_STATIC_PRODUCTNAME, m_wndFileDescription);
    DDX_Control(pDX, IDC_STATIC_DLL_VERSION, m_wndDllVersion);
	//}}AFX_DATA_MAP

}

BOOL AboutDlg::OnInitDialog() 
{
    CDialog::OnInitDialog();
	
    SetWindowText(("About " + VersionInfo::GetInstance().GetProductName()).c_str());

    CString str;
    str.Format(_T("Version %s"), VersionInfo::GetInstance().GetProductVersion().c_str());
    m_wndProductVersion.SetWindowText(str);

    str.Format(_T("%s %s"),
        VersionInfo::GetInstance().GetLegalCopyright().c_str(),
        VersionInfo::GetInstance().GetCompanyName().c_str());
    m_wndLegalCopyright.SetWindowText(str);

    m_wndFileDescription.SetWindowText(VersionInfo::GetInstance().GetFileDescription().c_str());

    // m_wndDllVersion
    CString DllVersion;
    std::vector<BYTE> versionInfo;
    if(::GetVersionInfo("ConManDll.dll", versionInfo)) {
        TCHAR label[] = TEXT("\\");
        UINT fixedLength = 0;
        VS_FIXEDFILEINFO* pFixedInfo = NULL;
        if(VerQueryValue(&versionInfo[0], label, (void**)&pFixedInfo, &fixedLength)) {
            std::ostringstream os;
            os << std::setw(1) << std::setfill(TEXT('0')) << HIWORD(pFixedInfo->dwFileVersionMS) << '.'
               << std::setw(1) << std::setfill(TEXT('0')) << LOWORD(pFixedInfo->dwFileVersionMS) << '.'
               << std::setw(1) << std::setfill(TEXT('0')) << HIWORD(pFixedInfo->dwFileVersionLS) << '.'
               << std::setw(1) << std::setfill(TEXT('0')) << LOWORD(pFixedInfo->dwFileVersionLS);
            DllVersion = os.str().c_str();
            DllVersion = "ConManDll.dll Version " + DllVersion;
        }
    } 

    m_wndDllVersion.SetWindowText(DllVersion);

    return TRUE;  
}
