///////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2011 Cinterion Wireless Modules GmbH
//
// This software is protected by international intellectual property laws and
// treaties.
// Cinterion Wireless Modules GmbH ("Cinterion") grants to customer a limited,
// non-exclusive, non-transferable, royalty-free license to use the source code
// as a sample implementation and for the purpose of evaluation, analysis and
// to provide feedback thereon to Cinterion. Any right, title and interest in
// and to the source code, other than those expressly granted to the customer
// under this agreement, shall remain vested with Cinterion. This license may
// be terminated by Cinterion at any time in writing. Customer undertakes not
// to provide third parties with the source code. In particular, Customer is
// not allowed to sell the source code.
// The information contained in this document is considered the CONFIDENTIAL
// and PROPRIETARY information of Cinterion Wireless Modules GmbH and may not
// be disclosed or discussed with anyone who is not employed by Cinterion
// Wireless Modules GmbH, unless the individual/ company:
//
// i)  has an express need to know such information, and
//
// ii) disclosure of information is subject to the terms of a duly executed
//     Confidentiality and Non-Disclosure Agreement between Cinterion Wireless
//     Modules GmbH and the individual / company.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// CINTERION, ITS LEGAL REPRESENTATIVES AND VICARIOUS AGENTS SHALL 
// IRRESPECTIVE OF THE LEGAL GROUND  ONLY BE LIABLE FOR DAMAGES IF THE DAMAGE
// WAS CAUSED THROUGH CULPABLE BREACH OF A MAJOR CONTRACTUAL OBLIGATION
// (CARDINAL DUTY), I.E. A DUTY THE FULFILMENT OF WHICH ALLOWS THE PROPER
// EXECUTION OF THE RESPECTIVE AGREEMENT IN THE FIRST PLACE OR THE BREACH OF
// WHICH PUTS THE ACHIEVEMENT OF THE PURPOSE OF THE AGREEMENT AT STAKE,
// RESPECTIVELY, AND ON THE FULFILMENT OF WHICH THE RECIPIENT THEREFORE MAY
// RELY ON OR WAS CAUSED BY GROSS NEGLIGENCE OR INTENTIONALLY. ANY FURTHER
// LIABILITY FOR DAMAGES SHALL  IRRESPECTIVE OF THE LEGAL GROUND  BE
// EXCLUDED. IN THE EVENT THAT CINTERION IS LIABLE FOR THE VIOLATION OF A MAJOR
// CONTRACTUAL OBLIGATION IN THE ABSENCE OF GROSS NEGLIGENCE OR WILFUL CONDUCT,
// SUCH LIABILITY FOR DAMAGE SHALL BE LIMITED TO AN EXTENT WHICH, AT THE TIME
// WHEN THE RESPECTIVE AGREEMENT IS CONCLUDED, CINTERION SHOULD NORMALLY EXPECT
// TO ARISE DUE TO CIRCUMSTANCES THAT THE PARTIES HAD KNOWLEDGE OF AT SUCH
// POINT IN TIME. CINTERION SHALL IN NO EVENT BE LIABLE FOR INDIRECT AND
// CONSEQUENTIAL DAMAGES OR LOSS OF PROFIT. CINTERION SHALL IN NO EVENT BE
// LIABLE FOR AN AMOUNT EXCEEDING  20,000.00 PER EVENT OF DAMAGE. WITHIN THE
// BUSINESS RELATIONSHIP THE OVERALL LIABILITY SHALL BE LIMITED TO A TOTAL OF
//  100,000.00. CLAIMS FOR DAMAGES SHALL BECOME TIME-BARRED AFTER ONE YEAR AS
// OF THE BEGINNING OF THE STATUTORY LIMITATION PERIOD. IRRESPECTIVE OF THE
// LICENSEES KNOWLEDGE OR GROSS NEGLIGENT LACK OF KNOWLEDGE OF THE
// CIRCUMSTANCES GIVING RISE FOR A LIABILITY ANY CLAIMS SHALL BECOME
// TIME-BARRED AFTER FIVE YEARS AS OF THE LIABILITY AROSE. THE AFOREMENTIONED
// LIMITATION OR EXCLUSION OF LIABILITY SHALL NOT APPLY IN THE CASE OF CULPABLE
// INJURY TO LIFE, BODY OR HEALTH, IN CASE OF INTENTIONAL ACTS, UNDER THE
// LIABILITY PROVISIONS OF THE GERMAN PRODUCT LIABILITY ACT
// (PRODUKTHAFTUNGSGESETZ) OR IN CASE OF A CONTRACTUALLY AGREED OBLIGATION TO
// ASSUME LIABILITY IRRESPECTIVE OF ANY FAULT (GUARANTEE).
//
// IN THE EVENT OF A CONFLICT BETWEEN THE PROVISIONS OF THIS AGREEMENT AND
// ANOTHER AGREEMENT REGARDING THE SOURCE CODE (EXCEPT THE GENERAL TERMS AND
// CONDITIONS OF CINTERION) THE OTHER AGREEMENT SHALL PREVAIL.
//
// All rights created by patent grant or registration of a utility model or
// design patent are reserved.
//
///////////////////////////////////////////////////////////////////////////////

#include <sstream>
#include "stdafx.h"
#include "ConnectionPage.h"
#include "ConnectionManagerDlg.h"
#include "Resource.h"


BEGIN_MESSAGE_MAP(ConnectionPage, CPropertyPage)
    ON_WM_SETCURSOR()
    ON_CBN_SELENDOK(IDC_DEVICE_NAME_COMBO,OnDeviceSelect)
    ON_BN_CLICKED(IDC_PRIMARY_DNS_CHECK,OnPrimaryDnsCheck)
    ON_BN_CLICKED(IDC_SECONDARY_DNS_CHECK,OnSecondaryDnsCheck)
    ON_BN_CLICKED(IDC_PRIMARY_NBNS_CHECK,OnPrimaryNbnsCheck)
    ON_BN_CLICKED(IDC_SECONDARY_NBNS_CHECK,OnSecondaryNbnsCheck)
    ON_BN_CLICKED(IDC_APN_NAME_CHECK,OnApnNameCheck)
    ON_BN_CLICKED(IDC_IP_ADDR_CHECK,OnIpAddressCheck)
    ON_BN_CLICKED(IDC_AUTH_PREF_CHECK,OnAuthPrefCheck)
    ON_BN_CLICKED(IDC_USERNAME_CHECK,OnUsernameCheck)
    ON_BN_CLICKED(IDC_PASSWORD_CHECK,OnPasswordCheck)
    ON_BN_CLICKED(IDC_CONNECT_BUTTON,OnConnect)
END_MESSAGE_MAP()


// --------------------------------------------------------------------------
// constructor
// --------------------------------------------------------------------------
ConnectionPage::ConnectionPage() : 
    CPropertyPage(IDD_CONNECTION_PAGE),
    m_pCMDlg(NULL),
    m_useWaitCursor(false),
    m_isSelected(false),
    m_isConnected(false),
    m_isPBT_APMSUSPEND(false),
    m_pktDataHandle(0),
    m_txId(0)
{
    m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button
}

// --------------------------------------------------------------------------
// SetCMDlg
// --------------------------------------------------------------------------
void ConnectionPage::SetCMDlg(ConnectionManagerDlg* pCMDlg)
{
    m_pCMDlg = pCMDlg;
}

// --------------------------------------------------------------------------
// DoDataExchange
// --------------------------------------------------------------------------
void ConnectionPage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_SELECT_DEVICE_STATIC, m_selectDeviceStatic);
    DDX_Control(pDX, IDC_DEVICE_NAME_COMBO, m_deviceNameCombo);
    DDX_Control(pDX, IDC_OVERRIDE_GROUP, m_overrideGoup);
    DDX_Control(pDX, IDC_PRIMARY_DNS_CHECK, m_primaryDnsCheck);
    DDX_Control(pDX, IDC_PRIMARY_DNS_IPADDRESS, m_primaryDnsIpAddr);
    DDX_Control(pDX, IDC_SECONDARY_DNS_CHECK, m_secondaryDnsCheck);
    DDX_Control(pDX, IDC_SECONDARY_DNS_IPADDRESS, m_secondaryDnsIpAddr);
    DDX_Control(pDX, IDC_PRIMARY_NBNS_CHECK, m_primaryNbnsCheck);
    DDX_Control(pDX, IDC_PRIMARY_NBNS_IPADDRESS, m_primaryNbnsIpAddr);
    DDX_Control(pDX, IDC_SECONDARY_NBNS_CHECK, m_secondaryNbnsCheck);
    DDX_Control(pDX, IDC_SECONDARY_NBNS_IPADDRESS, m_secondaryNbnsIpAddr);
    DDX_Control(pDX, IDC_APN_NAME_CHECK, m_apnNameCheck);
    DDX_Control(pDX, IDC_APN_NAME_EDIT, m_apnNameEdit);
    DDX_Control(pDX, IDC_IP_ADDR_CHECK, m_ipAddressCheck);
    DDX_Control(pDX, IDC_IP_ADDR_IPADDRESS, m_ipAddressIpAddr);
    DDX_Control(pDX, IDC_AUTH_PREF_CHECK, m_authPrefCheck);
    DDX_Control(pDX, IDC_AUTH_PREF_COMBO, m_authPrefCombo);
    DDX_Control(pDX, IDC_USERNAME_CHECK, m_usernameCheck);
    DDX_Control(pDX, IDC_USERNAME_EDIT, m_usernameEdit);
    DDX_Control(pDX, IDC_PASSWORD_CHECK, m_passwordCheck);
    DDX_Control(pDX, IDC_PASSWORD_EDIT, m_passwordEdit);
    DDX_Control(pDX, IDC_CONNECT_BUTTON, m_connectButton);
    DDX_Control(pDX, IDC_SIGNAL_STATIC, m_signalStatic);
    DDX_Control(pDX, IDC_STATIC_RF_TECH, m_RFTech);
    DDX_Control(pDX, IDC_SIGNAL_PROGRESS, m_signalProgress);
    DDX_Control(pDX, IDC_AUTOCONNECT_CHECK, m_autoconnectCheck);
    DDX_Control(pDX, IDC_CS_ATTACHSTATE_STATIC, m_CSAttachStateStatic);
    DDX_Control(pDX, IDC_PS_ATTACHSTATE_STATIC, m_PSAttachStateStatic);
    DDX_Control(pDX, IDC_STATIC_REG_STATE, m_RegStateStatic);
    
}

// --------------------------------------------------------------------------
// OnInitDialog
// --------------------------------------------------------------------------
BOOL ConnectionPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

    DisableSelectedState();

    // start with no devices
    m_deviceNameCombo.AddString(_T("No Device Detected"));
    m_deviceNameCombo.SetCurSel(0);

    // add predefined values to the authentication preference combo box
    m_authPrefCombo.AddString(_T("PAP"));
    m_authPrefCombo.AddString(_T("CHAP"));
    m_authPrefCombo.AddString(_T("PAP and CHAP"));
    m_authPrefCombo.SetCurSel(0);

    m_primaryDnsCheck.SetCheck (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Override"), _T("primaryDnsCheck"), 0));
    m_primaryDnsIpAddr.SetWindowText (((CWinApp *)AfxGetApp())->GetProfileString (_T("Override"), _T("primaryDnsIpAddr"), ""));

    m_secondaryDnsCheck.SetCheck (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Override"), _T("secondaryDnsCheck"), 0));
    m_secondaryDnsIpAddr.SetWindowText (((CWinApp *)AfxGetApp())->GetProfileString (_T("Override"), _T("secondaryDnsIpAddr"), ""));

    m_primaryNbnsCheck.SetCheck (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Override"), _T("primaryNbnsCheck"), 0));
    m_primaryNbnsIpAddr.SetWindowText (((CWinApp *)AfxGetApp())->GetProfileString (_T("Override"), _T("primaryNbnsIpAddr"), ""));

    m_secondaryNbnsCheck.SetCheck (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Override"), _T("secondaryNbnsCheck"), 0));
    m_secondaryNbnsIpAddr.SetWindowText (((CWinApp *)AfxGetApp())->GetProfileString (_T("Override"), _T("secondaryNbnsIpAddr"), ""));

    m_apnNameCheck.SetCheck (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Override"), _T("apnNameCheck"), 0));
    m_apnNameEdit.SetWindowText (((CWinApp *)AfxGetApp())->GetProfileString (_T("Override"), _T("apnNameEdit"), ""));

    m_ipAddressCheck.SetCheck (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Override"), _T("ipAddressCheck"), 0));
    m_ipAddressIpAddr.SetWindowText (((CWinApp *)AfxGetApp())->GetProfileString (_T("Override"), _T("ipAddressIpAddr"), ""));

    m_authPrefCheck.SetCheck (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Override"), _T("authPrefCheck"), 0));
    m_authPrefCombo.SetCurSel (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Override"), _T("authPrefCombo"), 0));
	
    m_usernameCheck.SetCheck (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Override"), _T("usernameCheck"), 0));
	m_usernameEdit.SetWindowText (((CWinApp *)AfxGetApp())->GetProfileString (_T("Override"), _T("usernameEdit"), ""));

    m_passwordCheck.SetCheck (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Override"), _T("passwordCheck"), 0));
	m_passwordEdit.SetWindowText (((CWinApp *)AfxGetApp())->GetProfileString (_T("Override"), _T("passwordEdit"), ""));

    m_autoconnectCheck.SetCheck (((CWinApp *)AfxGetApp())->GetProfileInt (_T("Settings"), _T("autoconnectCheck"), 0));

    m_RFTech.SetWindowText("");
    m_signalProgress.SetRange(0,100);

    m_RegStateStatic.SetWindowText("");

	return TRUE;  
}

// --------------------------------------------------------------------------
// OnPowerbroadcast
//
// Actions to take when a powerbroadcast message is received from the PC.
// --------------------------------------------------------------------------
LRESULT ConnectionPage::OnPowerbroadcast(WPARAM wParam,LPARAM lParam)
{
    switch (wParam) {
        case PBT_APMSUSPEND:
            m_isPBT_APMSUSPEND = TRUE;
            break;

        case PBT_APMRESUMESUSPEND:
            m_isPBT_APMSUSPEND = FALSE;
            PostMessage(WM_COMMAND, MAKEWPARAM(IDC_DEVICE_NAME_COMBO, CBN_SELENDOK), (LPARAM)GetDlgItem(IDC_DEVICE_NAME_COMBO)->m_hWnd);
            UpdateWindow();

            break;
    }
    return NULL;
}

// --------------------------------------------------------------------------
// PopulateDeviceNames
//
// Populate the device name combo box with attached network adapters
//
// Parameters 
// networkAdapters  : vector of string representations of network adapters.
// --------------------------------------------------------------------------
void ConnectionPage::PopulateDeviceNames(std::vector<std::string>& networkAdapters)
{
    // clear any existing entries
    m_deviceNameCombo.ResetContent();
    int size = (int)networkAdapters.size();

    // check for an empty list
    if (size == 0)
    {
        m_deviceNameCombo.AddString(_T("No Device Detected"));
        m_deviceNameCombo.SetCurSel(0);
        return;
    }

    // read user profile
    CString UserDeviceName = ((CWinApp *)AfxGetApp())->GetProfileString (_T("Override"), _T("devicenameCombo"), "");

    int     nUserCurSel = -1;
    // add device names
    for (int i = 0; i < size; i++)
    {
        if (UserDeviceName.Compare(networkAdapters[i].c_str()) == 0)
        {
            nUserCurSel = i;
        }
        m_deviceNameCombo.AddString(networkAdapters[i].c_str());
    }

    // automatic device selection
    /* test
    if (nUserCurSel >= 0) {
	    m_deviceNameCombo.SetCurSel(nUserCurSel);

        if (!m_isPBT_APMSUSPEND) {
            // simulate OnDeviceSelect();
            PostMessage(WM_COMMAND, MAKEWPARAM(IDC_DEVICE_NAME_COMBO, CBN_SELENDOK), (LPARAM)GetDlgItem(IDC_DEVICE_NAME_COMBO)->m_hWnd);
        }
    }
    */
}

// --------------------------------------------------------------------------
// OnSetCursor
//
// Change to custom cursor if m_changeCursor = true.
// --------------------------------------------------------------------------
BOOL ConnectionPage::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
    CPoint point(GetMessagePos());
    ScreenToClient(&point);
    
    // use wait cursor, if set, but not over the connect button
    if (m_useWaitCursor && !(&m_connectButton == ChildWindowFromPoint(point)))
    {
        ::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
        return TRUE;
    }

    return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

// --------------------------------------------------------------------------
// OnDeviceSelect
//
// Actions to take when a device name is selected from the device name combo
// box.
// --------------------------------------------------------------------------
void ConnectionPage::OnDeviceSelect()
{
    // get device name from combo box
    CString deviceName;
    m_deviceNameCombo.GetWindowText(deviceName);   

    // device name required to connect
    if (deviceName.Compare("No Device Detected") == 0 ||
        deviceName.Compare("") == 0)
    {
        return;
    }

    // do nothing if device is already selected
    if (deviceName == m_deviceName)
    {
        return;
    }

    ((CWinApp *)AfxGetApp())->WriteProfileString (_T("Override"), _T("devicenameCombo"), deviceName);

    // disconnect existing conection
    if (m_isSelected)
    {
        m_pCMDlg->DeselectDevice();
        return;
    }

    m_deviceName = deviceName;

    // connect to device
    m_pCMDlg->SelectDevice(m_deviceName);
}

// --------------------------------------------------------------------------
// EnableSelectedState
//
// Show availabe fields and send requests to populate them.
// --------------------------------------------------------------------------
void ConnectionPage::EnableSelectedState()
{
    // set the device connected flag
    m_isSelected = true;

    // enable/disable appropriate fields
    m_overrideGoup.EnableWindow(TRUE);
    m_primaryDnsCheck.EnableWindow(TRUE);
    OnPrimaryDnsCheck();
    m_secondaryDnsCheck.EnableWindow(TRUE);
    OnSecondaryDnsCheck();
    m_primaryNbnsCheck.EnableWindow(TRUE);
    OnPrimaryNbnsCheck();
    m_secondaryNbnsCheck.EnableWindow(TRUE);
    OnSecondaryNbnsCheck();
    m_apnNameCheck.EnableWindow(TRUE);
    OnApnNameCheck();
    m_ipAddressCheck.EnableWindow(TRUE);
    OnIpAddressCheck();
    m_authPrefCheck.EnableWindow(TRUE);
    OnAuthPrefCheck();
    m_usernameCheck.EnableWindow(TRUE);
    OnUsernameCheck();
    m_passwordCheck.EnableWindow(TRUE);
    OnPasswordCheck();
    m_connectButton.EnableWindow(TRUE);
    m_signalStatic.SetIcon((HICON)LoadImage(
        AfxGetInstanceHandle(),
        MAKEINTRESOURCE(IDI_SIGNAL_ICON),
        IMAGE_ICON,0,0,LR_LOADTRANSPARENT
        ));
    m_signalProgress.EnableWindow(TRUE);

    // send signal strength request and event report request
    CReqGetSignalStrength Msg; 
    Msg.SendRequest();

    CReqSetEventReport ReportMsg;
    ReqSetEventReport (ReportMsg);
    ReportMsg.SendRequest();

    // send serving system request
    CReqServingSystem ServingSystemMsg;
    ServingSystemMsg.SendRequest();
}

// --------------------------------------------------------------------------
// DisableSelectedState
//
// Dim fields that should not be accessed.
// --------------------------------------------------------------------------
void ConnectionPage::DisableSelectedState()
{
    // disable started state if necessary
    if (m_isConnected)
    {
        DisableConnectedState();
    }

    // set the device connected flag, clear the device name
    m_isSelected = false;
    m_deviceName.Empty();

    // enable/disable appropriate fields
    m_overrideGoup.EnableWindow(FALSE);
    m_primaryDnsCheck.EnableWindow(FALSE);
    m_primaryDnsIpAddr.EnableWindow(FALSE);
    m_secondaryDnsCheck.EnableWindow(FALSE);
    m_secondaryDnsIpAddr.EnableWindow(FALSE);
    m_primaryNbnsCheck.EnableWindow(FALSE);
    m_primaryNbnsIpAddr.EnableWindow(FALSE);
    m_secondaryNbnsCheck.EnableWindow(FALSE);
    m_secondaryNbnsIpAddr.EnableWindow(FALSE);
    m_apnNameCheck.EnableWindow(FALSE);
    m_apnNameEdit.EnableWindow(FALSE);
    m_ipAddressCheck.EnableWindow(FALSE);
    m_ipAddressIpAddr.EnableWindow(FALSE);
    m_authPrefCheck.EnableWindow(FALSE);
    m_authPrefCombo.EnableWindow(FALSE);
    m_usernameCheck.EnableWindow(FALSE);
    m_usernameEdit.EnableWindow(FALSE);
    m_passwordCheck.EnableWindow(FALSE);
    m_passwordEdit.EnableWindow(FALSE);
    m_connectButton.EnableWindow(FALSE);
    m_signalStatic.SetIcon((HICON)LoadImage(
        AfxGetInstanceHandle(),
        MAKEINTRESOURCE(IDI_DIM_SIGNAL_ICON),
        IMAGE_ICON,0,0,LR_LOADTRANSPARENT
        ));
    m_RFTech.SetWindowText("");
    m_RegStateStatic.SetWindowText("");
    m_signalProgress.SetPos(0);
    m_signalProgress.EnableWindow(FALSE);

    m_CSAttachStateStatic.ShowWindow(SW_HIDE);
    m_PSAttachStateStatic.ShowWindow(SW_HIDE);


}

// --------------------------------------------------------------------------
// ProcessSignalStrength
//
// Activate the appropriate signal strength indicators on the page.
//
// Parameters
// signalStrength   : signal strength level of the device.
// radioIf          : radio interface technology of from the device.
// --------------------------------------------------------------------------
void ConnectionPage::ProcessSignalStrength(INT signalStrength, BYTE radioIf)
{
    // set RF Tech text
    m_RFTech.SetWindowText(CMDAPI_RADIO_IF_TECH_STRINGS[radioIf]);

    // -80 (full strength) to -106 dBm (no signal).

    // calculate position
    int pos = (int)((double)(signalStrength + 106)*100/(double)(-80 + 106));

    // set position
    m_signalProgress.SetPos(pos);
}


// --------------------------------------------------------------------------
// ProcessMsgGetSignalStrengthRsp
//
// Actions to take when a CGetSignalStrengthRsp message is received.
//
// Parameters
// pMsg         : Message pointer to process.
// --------------------------------------------------------------------------
void ConnectionPage::ProcessMsgGetSignalStrengthRsp(CGetSignalStrengthRsp *pMsg)
{
    // get signal strength info
    INT  signalStrength = pMsg->GetSignalStrength();
    BYTE radioIf        = pMsg->GetRadioIf();

    // activate the appropriate signal strength indicators
    ProcessSignalStrength(signalStrength, radioIf);
}

// --------------------------------------------------------------------------
// ProcessMsgEventReportInd
//
// Actions to take when a CEventReportInd message is received.
//
// Parameters
// pMsg         : Message pointer to process.
// --------------------------------------------------------------------------
void ConnectionPage::ProcessMsgEventReportInd(CEventReportInd *pMsg)
{
    // get signal strength info
    INT signalStrength = pMsg->GetSignalStrength();
    BYTE radioIf = pMsg->GetRadioIf();

    // activate the appropriate signal strength indicators
    ProcessSignalStrength(signalStrength,radioIf);
}

void ConnectionPage::ProcessMsgStatusConnectionInd (CMsgStatusConnectionInd * pMsg)
{
    // get connection status
    unsigned int connectionStatus = pMsg->GetConnectionStatus();

    if (m_isConnected && connectionStatus == STATUS_PKT_DATA_DISCONNECTED) {
        DisableConnectedState();
    }
}

// --------------------------------------------------------------------------
// ProcessAttachState
//
// Activate the appropriate cs/ps attach state indicators on the page.
//
// Parameters
// CSAttachState    : circuit switch attach state of the device.
// PSAttachState    : packet switch attach state of the device.
// --------------------------------------------------------------------------
void ConnectionPage::ProcessAttachState(BYTE CSAttachState, BYTE PSAttachState)
{
    // cs attach state
    if (CSAttachState == 1)
    {
        m_CSAttachStateStatic.ShowWindow(SW_SHOW);
    }
    else
    {
        m_CSAttachStateStatic.ShowWindow(SW_HIDE);
    }

    // ps attach state
    if (PSAttachState == 1)
    {
        m_PSAttachStateStatic.ShowWindow(SW_SHOW);
    }
    else
    {
        m_PSAttachStateStatic.ShowWindow(SW_HIDE);
    }
}

// --------------------------------------------------------------------------
// ProcessMsgServingSystemRsp
//
// Actions to take when a CServingSystemRsp message is received.
//
// Parameters
// pMsg         : Message pointer to process.
// --------------------------------------------------------------------------
void ConnectionPage::ProcessMsgServingSystemRsp(CServingSystemRsp *pMsg)
{
    m_RegStateStatic.SetWindowText(CMDAPI_REG_STATE_STRINGS[pMsg->GetRegistrationState()]);

    ProcessAttachState (pMsg->GetCSAttachState(), pMsg->GetPSAttachState());
}

// --------------------------------------------------------------------------
// ProcessMsgServingSystemInd
//
// Actions to take when a CServingSystemInd message is received.
//
// Parameters
// pMsg         : Message pointer to process.
// --------------------------------------------------------------------------
void ConnectionPage::ProcessMsgServingSystemInd(CServingSystemInd *pMsg)
{
    m_RegStateStatic.SetWindowText(CMDAPI_REG_STATE_STRINGS[pMsg->GetRegistrationState()]);

    ProcessAttachState (pMsg->GetCSAttachState(), pMsg->GetPSAttachState());
}


// --------------------------------------------------------------------------
// OnPrimaryDnsCheck
//
// Actions to take when the primary dns check box is clicked.
// --------------------------------------------------------------------------
void ConnectionPage::OnPrimaryDnsCheck()
{
    BOOL isChecked = (m_primaryDnsCheck.GetCheck() == BST_CHECKED);
    m_primaryDnsIpAddr.EnableWindow(isChecked);
}

// --------------------------------------------------------------------------
// OnSecondaryDnsCheck
//
// Actions to take when the secondary dns check box is clicked.
// --------------------------------------------------------------------------
void ConnectionPage::OnSecondaryDnsCheck()
{
    BOOL isChecked = (m_secondaryDnsCheck.GetCheck() == BST_CHECKED);
    m_secondaryDnsIpAddr.EnableWindow(isChecked);
}

// --------------------------------------------------------------------------
// OnPrimaryNbnsCheck
//
// Actions to take when the primary nbns check box is clicked.
// --------------------------------------------------------------------------
void ConnectionPage::OnPrimaryNbnsCheck()
{
    BOOL isChecked = (m_primaryNbnsCheck.GetCheck() == BST_CHECKED);
    m_primaryNbnsIpAddr.EnableWindow(isChecked);
}

// --------------------------------------------------------------------------
// OnSecondaryNbnsCheck
//
// Actions to take when the secondary nbns check box is clicked.
// --------------------------------------------------------------------------
void ConnectionPage::OnSecondaryNbnsCheck()
{
    BOOL isChecked = (m_secondaryNbnsCheck.GetCheck() == BST_CHECKED);
    m_secondaryNbnsIpAddr.EnableWindow(isChecked);
}

// --------------------------------------------------------------------------
// OnApnNameCheck
//
// Actions to take when the apn name check box is clicked.
// --------------------------------------------------------------------------
void ConnectionPage::OnApnNameCheck()
{
    BOOL isChecked = (m_apnNameCheck.GetCheck() == BST_CHECKED);
    m_apnNameEdit.EnableWindow(isChecked);
}

// --------------------------------------------------------------------------
// OnIpAddressCheck
//
// Actions to take when the ip address check box is clicked.
// --------------------------------------------------------------------------
void ConnectionPage::OnIpAddressCheck()
{
    BOOL isChecked = (m_ipAddressCheck.GetCheck() == BST_CHECKED);
    m_ipAddressIpAddr.EnableWindow(isChecked);
}

// --------------------------------------------------------------------------
// OnAuthPrefCheck
//
// Actions to take when the authentication preference check box is clicked.
// --------------------------------------------------------------------------
void ConnectionPage::OnAuthPrefCheck()
{
    BOOL isChecked = (m_authPrefCheck.GetCheck() == BST_CHECKED);
    m_authPrefCombo.EnableWindow(isChecked);
}

// --------------------------------------------------------------------------
// OnUsernameCheck
//
// Actions to take when the username check box is clicked.
// --------------------------------------------------------------------------
void ConnectionPage::OnUsernameCheck()
{
    BOOL isChecked = (m_usernameCheck.GetCheck() == BST_CHECKED);
    m_usernameEdit.EnableWindow(isChecked);
}

// --------------------------------------------------------------------------
// OnPasswordCheck
//
// Actions to take when the password check box is clicked.
// --------------------------------------------------------------------------
void ConnectionPage::OnPasswordCheck()
{
    BOOL isChecked = (m_passwordCheck.GetCheck() == BST_CHECKED);
    m_passwordEdit.EnableWindow(isChecked);
}

// --------------------------------------------------------------------------
// OnConnect
//
// Actions to take when the connect button is pressed.
// --------------------------------------------------------------------------
void ConnectionPage::OnConnect()
{
    std::string msgStr;
    CString text;
    m_connectButton.GetWindowText(text);

    // determine action by button label
    if (text.Compare("Connect") == 0)
    {
        CReqStartConnection msg;
        // build start network interface request, enable abort
        ReqStartConnection (msg);
        EnableAbortState();
        SetTxId(msg.SendRequest());
    }
    else if (text.Compare("Abort") == 0)
    {
        // build abort network interface request
        CReqAbortConnection msg(m_txId);
        msg.SendRequest();
    }
    else if (text.Compare("Disconnect") == 0)
    {
        // build stop network interface request
        CReqStopConnection msg(m_pktDataHandle);
        msg.SendRequest();
    }
    else
    {
        AfxMessageBox(_T("Connect button has invalid text."));
    }
}
// --------------------------------------------------------------------------
// BuildReqStartConnection
//
// Build a CReqStartConnection message based on the user
// input.
//
// --------------------------------------------------------------------------
void ConnectionPage::ReqStartConnection(CReqStartConnection& msg)
{

    // primary dns
    if (m_primaryDnsCheck.GetCheck() == BST_CHECKED)
    {
        CString primaryDns;
        m_primaryDnsIpAddr.GetWindowText(primaryDns);
        msg.SetPrimaryDnsPref (primaryDns);
    }

    // secondary dns
    if (m_secondaryDnsCheck.GetCheck() == BST_CHECKED)
    {
        CString secondaryDns;
        m_secondaryDnsIpAddr.GetWindowText(secondaryDns);
        msg.SetSecondaryDnsPref (secondaryDns);
    }

    // primary Nbns
    if (m_primaryNbnsCheck.GetCheck() == BST_CHECKED)
    {
        CString primaryNbns;
        m_primaryNbnsIpAddr.GetWindowText(primaryNbns);
        msg.SetPrimaryNbnsPref (primaryNbns);
    }

    // secondary nbns
    if (m_secondaryNbnsCheck.GetCheck() == BST_CHECKED)
    {
        CString secondaryNbns;
        m_secondaryNbnsIpAddr.GetWindowText(secondaryNbns);
        msg.SetSecondaryNbnsPref (secondaryNbns);
    }

    // apn name
    if (m_apnNameCheck.GetCheck() == BST_CHECKED)
    {
        CString apnName;
        m_apnNameEdit.GetWindowText(apnName);
        msg.SetApnName (apnName);
    }

    // ip address
    if (m_ipAddressCheck.GetCheck() == BST_CHECKED)
    {
        CString ipAddress;
        m_ipAddressIpAddr.GetWindowText(ipAddress);
        msg.SetIpv4AddrPref (ipAddress);
    }

    // authentication preference
    if (m_authPrefCheck.GetCheck() == BST_CHECKED)
    {
        int idx = m_authPrefCombo.GetCurSel();
        msg.SetAuthPref ((int)(idx + 1));
    }

    // username
    if (m_usernameCheck.GetCheck() == BST_CHECKED)
    {
        CString username;
        m_usernameEdit.GetWindowText(username);
        msg.SetUsername (username);
    }

    // password
    if (m_passwordCheck.GetCheck() == BST_CHECKED)
    {
        CString password;
        m_passwordEdit.GetWindowText(password);
        msg.SetPassword (password);
    }

    return;
}

// --------------------------------------------------------------------------
// ReqSetEventReport
//
// Build a CReqSetEventReport message.
//
// --------------------------------------------------------------------------
void ConnectionPage::ReqSetEventReport(CReqSetEventReport& msg)
{
    signed char RangeLimits[5] = {-106, -100, -93, -86, -80};

    msg.SetReport(TRUE);
    msg.SetRangeLimits(5, RangeLimits);

    return;
}



// --------------------------------------------------------------------------
// EnableConnectedState
//
// Show availabe fields.
// --------------------------------------------------------------------------
void ConnectionPage::EnableConnectedState(UINT pktDataHandle)
{
    // set interface started flag
    m_isConnected = true;

    // store the packet data handle
    m_pktDataHandle = pktDataHandle;

    // use arrow cursor
    m_useWaitCursor = false;

    // disable user inputs, change button:start interface to stop interface
    m_selectDeviceStatic.EnableWindow(FALSE);
    m_deviceNameCombo.EnableWindow(FALSE);
    m_overrideGoup.EnableWindow(FALSE);
    m_primaryDnsCheck.EnableWindow(FALSE);
    m_primaryDnsIpAddr.EnableWindow(FALSE);
    m_secondaryDnsCheck.EnableWindow(FALSE);
    m_secondaryDnsIpAddr.EnableWindow(FALSE);
    m_primaryNbnsCheck.EnableWindow(FALSE);
    m_primaryNbnsIpAddr.EnableWindow(FALSE);
    m_secondaryNbnsCheck.EnableWindow(FALSE);
    m_secondaryNbnsIpAddr.EnableWindow(FALSE);
    m_apnNameCheck.EnableWindow(FALSE);
    m_apnNameEdit.EnableWindow(FALSE);
    m_ipAddressCheck.EnableWindow(FALSE);
    m_ipAddressIpAddr.EnableWindow(FALSE);
    m_authPrefCheck.EnableWindow(FALSE);
    m_authPrefCombo.EnableWindow(FALSE);
    m_usernameCheck.EnableWindow(FALSE);
    m_usernameEdit.EnableWindow(FALSE);
    m_passwordCheck.EnableWindow(FALSE);
    m_passwordEdit.EnableWindow(FALSE);
    m_connectButton.SetWindowText(_T("Disconnect"));
}

// --------------------------------------------------------------------------
// EnableAbortState
//
// Show availabe fields.
// --------------------------------------------------------------------------
void ConnectionPage::EnableAbortState()
{
    // use wait cursor
    m_useWaitCursor = true;

    // disable user inputs, change button:start interface to stop interface
    m_selectDeviceStatic.EnableWindow(FALSE);
    m_deviceNameCombo.EnableWindow(FALSE);
    m_overrideGoup.EnableWindow(FALSE);
    m_primaryDnsCheck.EnableWindow(FALSE);
    m_primaryDnsIpAddr.EnableWindow(FALSE);
    m_secondaryDnsCheck.EnableWindow(FALSE);
    m_secondaryDnsIpAddr.EnableWindow(FALSE);
    m_primaryNbnsCheck.EnableWindow(FALSE);
    m_primaryNbnsIpAddr.EnableWindow(FALSE);
    m_secondaryNbnsCheck.EnableWindow(FALSE);
    m_secondaryNbnsIpAddr.EnableWindow(FALSE);
    m_apnNameCheck.EnableWindow(FALSE);
    m_apnNameEdit.EnableWindow(FALSE);
    m_ipAddressCheck.EnableWindow(FALSE);
    m_ipAddressIpAddr.EnableWindow(FALSE);
    m_authPrefCheck.EnableWindow(FALSE);
    m_authPrefCombo.EnableWindow(FALSE);
    m_usernameCheck.EnableWindow(FALSE);
    m_usernameEdit.EnableWindow(FALSE);
    m_passwordCheck.EnableWindow(FALSE);
    m_passwordEdit.EnableWindow(FALSE);
    m_connectButton.SetWindowText(_T("Abort"));
}

// --------------------------------------------------------------------------
// DisableConnectedState
//
// Dim fields that should not be accessed.
// --------------------------------------------------------------------------
void ConnectionPage::DisableConnectedState()
{
    // set interface started flag
    m_isConnected = false;

    // reset the packet data handle
    m_pktDataHandle = 0;

    // use arrow cursor
    m_useWaitCursor = false;

    // enable user inputs, change button:start interface to stop interface
    m_selectDeviceStatic.EnableWindow(TRUE);
    m_deviceNameCombo.EnableWindow(TRUE);
    m_overrideGoup.EnableWindow(TRUE);
    m_primaryDnsCheck.EnableWindow(TRUE);
    OnPrimaryDnsCheck();
    m_secondaryDnsCheck.EnableWindow(TRUE);
    OnSecondaryDnsCheck();
    m_primaryNbnsCheck.EnableWindow(TRUE);
    OnPrimaryNbnsCheck();
    m_secondaryNbnsCheck.EnableWindow(TRUE);
    OnSecondaryNbnsCheck();
    m_apnNameCheck.EnableWindow(TRUE);
    OnApnNameCheck();
    m_ipAddressCheck.EnableWindow(TRUE);
    OnIpAddressCheck();
    m_authPrefCheck.EnableWindow(TRUE);
    OnAuthPrefCheck();
    m_usernameCheck.EnableWindow(TRUE);
    OnUsernameCheck();
    m_passwordCheck.EnableWindow(TRUE);
    OnPasswordCheck();
    m_connectButton.SetWindowText(_T("Connect"));
}

// --------------------------------------------------------------------------
// SaveUserData
//
// save default data -> registry
// --------------------------------------------------------------------------
void ConnectionPage::SaveUserData(void)
{
    CString ComboContent;

    ((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Override"), _T("primaryDnsCheck"), m_primaryDnsCheck.GetCheck());
    m_primaryDnsIpAddr.GetWindowText(ComboContent);
    ((CWinApp *)AfxGetApp())->WriteProfileString (_T("Override"), _T("primaryDnsIpAddr"), ComboContent);

    ((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Override"), _T("secondaryDnsCheck"), m_secondaryDnsCheck.GetCheck());
    m_secondaryDnsIpAddr.GetWindowText(ComboContent);
    ((CWinApp *)AfxGetApp())->WriteProfileString (_T("Override"), _T("secondaryDnsIpAddr"), ComboContent);

    ((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Override"), _T("primaryNbnsCheck"), m_primaryNbnsCheck.GetCheck());
    m_primaryNbnsIpAddr.GetWindowText(ComboContent);
    ((CWinApp *)AfxGetApp())->WriteProfileString (_T("Override"), _T("primaryNbnsIpAddr"), ComboContent);

    ((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Override"), _T("secondaryNbnsCheck"), m_secondaryNbnsCheck.GetCheck());
    m_secondaryNbnsIpAddr.GetWindowText(ComboContent);
    ((CWinApp *)AfxGetApp())->WriteProfileString (_T("Override"), _T("secondaryNbnsIpAddr"), ComboContent);

    m_deviceNameCombo.GetWindowText(ComboContent);
    ((CWinApp *)AfxGetApp())->WriteProfileString (_T("Override"), _T("devicenameCombo"), ComboContent);

    ((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Override"), _T("apnNameCheck"), m_apnNameCheck.GetCheck());
    m_apnNameEdit.GetWindowText(ComboContent);
    ((CWinApp *)AfxGetApp())->WriteProfileString (_T("Override"), _T("apnNameEdit"), ComboContent);

    ((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Override"), _T("ipAddressCheck"), m_ipAddressCheck.GetCheck());
    m_ipAddressIpAddr.GetWindowText(ComboContent);
    ((CWinApp *)AfxGetApp())->WriteProfileString (_T("Override"), _T("ipAddressIpAddr"), ComboContent);

	((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Override"), _T("authPrefCheck"), m_authPrefCheck.GetCheck());
	((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Override"), _T("authPrefCombo"), m_authPrefCombo.GetCurSel());
	
	((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Override"), _T("usernameCheck"), m_usernameCheck.GetCheck());
	m_usernameEdit.GetWindowText(ComboContent);
    ((CWinApp *)AfxGetApp())->WriteProfileString (_T("Override"), _T("usernameEdit"), ComboContent);

	((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Override"), _T("passwordCheck"), m_passwordCheck.GetCheck());
	m_passwordEdit.GetWindowText(ComboContent);
    ((CWinApp *)AfxGetApp())->WriteProfileString (_T("Override"), _T("passwordEdit"), ComboContent);

	((CWinApp *)AfxGetApp())->WriteProfileInt (_T("Settings"), _T("autoconnectCheck"), m_autoconnectCheck.GetCheck());

    return;
}

// --------------------------------------------------------------------------
// AutoConnect
//
// start connection by simulate a OnConnect() button click
// --------------------------------------------------------------------------
void ConnectionPage::AutoConnect(void)
{
    if (m_autoconnectCheck.GetCheck() == BST_CHECKED) {
        OnConnect();
    }
}
