///////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2011 Cinterion Wireless Modules GmbH
//
// This software is protected by international intellectual property laws and
// treaties.
// Cinterion Wireless Modules GmbH ("Cinterion") grants to customer a limited,
// non-exclusive, non-transferable, royalty-free license to use the source code
// as a sample implementation and for the purpose of evaluation, analysis and
// to provide feedback thereon to Cinterion. Any right, title and interest in
// and to the source code, other than those expressly granted to the customer
// under this agreement, shall remain vested with Cinterion. This license may
// be terminated by Cinterion at any time in writing. Customer undertakes not
// to provide third parties with the source code. In particular, Customer is
// not allowed to sell the source code.
// The information contained in this document is considered the CONFIDENTIAL
// and PROPRIETARY information of Cinterion Wireless Modules GmbH and may not
// be disclosed or discussed with anyone who is not employed by Cinterion
// Wireless Modules GmbH, unless the individual/ company:
//
// i)  has an express need to know such information, and
//
// ii) disclosure of information is subject to the terms of a duly executed
//     Confidentiality and Non-Disclosure Agreement between Cinterion Wireless
//     Modules GmbH and the individual / company.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// CINTERION, ITS LEGAL REPRESENTATIVES AND VICARIOUS AGENTS SHALL 
// IRRESPECTIVE OF THE LEGAL GROUND  ONLY BE LIABLE FOR DAMAGES IF THE DAMAGE
// WAS CAUSED THROUGH CULPABLE BREACH OF A MAJOR CONTRACTUAL OBLIGATION
// (CARDINAL DUTY), I.E. A DUTY THE FULFILMENT OF WHICH ALLOWS THE PROPER
// EXECUTION OF THE RESPECTIVE AGREEMENT IN THE FIRST PLACE OR THE BREACH OF
// WHICH PUTS THE ACHIEVEMENT OF THE PURPOSE OF THE AGREEMENT AT STAKE,
// RESPECTIVELY, AND ON THE FULFILMENT OF WHICH THE RECIPIENT THEREFORE MAY
// RELY ON OR WAS CAUSED BY GROSS NEGLIGENCE OR INTENTIONALLY. ANY FURTHER
// LIABILITY FOR DAMAGES SHALL  IRRESPECTIVE OF THE LEGAL GROUND  BE
// EXCLUDED. IN THE EVENT THAT CINTERION IS LIABLE FOR THE VIOLATION OF A MAJOR
// CONTRACTUAL OBLIGATION IN THE ABSENCE OF GROSS NEGLIGENCE OR WILFUL CONDUCT,
// SUCH LIABILITY FOR DAMAGE SHALL BE LIMITED TO AN EXTENT WHICH, AT THE TIME
// WHEN THE RESPECTIVE AGREEMENT IS CONCLUDED, CINTERION SHOULD NORMALLY EXPECT
// TO ARISE DUE TO CIRCUMSTANCES THAT THE PARTIES HAD KNOWLEDGE OF AT SUCH
// POINT IN TIME. CINTERION SHALL IN NO EVENT BE LIABLE FOR INDIRECT AND
// CONSEQUENTIAL DAMAGES OR LOSS OF PROFIT. CINTERION SHALL IN NO EVENT BE
// LIABLE FOR AN AMOUNT EXCEEDING  20,000.00 PER EVENT OF DAMAGE. WITHIN THE
// BUSINESS RELATIONSHIP THE OVERALL LIABILITY SHALL BE LIMITED TO A TOTAL OF
//  100,000.00. CLAIMS FOR DAMAGES SHALL BECOME TIME-BARRED AFTER ONE YEAR AS
// OF THE BEGINNING OF THE STATUTORY LIMITATION PERIOD. IRRESPECTIVE OF THE
// LICENSEES KNOWLEDGE OR GROSS NEGLIGENT LACK OF KNOWLEDGE OF THE
// CIRCUMSTANCES GIVING RISE FOR A LIABILITY ANY CLAIMS SHALL BECOME
// TIME-BARRED AFTER FIVE YEARS AS OF THE LIABILITY AROSE. THE AFOREMENTIONED
// LIMITATION OR EXCLUSION OF LIABILITY SHALL NOT APPLY IN THE CASE OF CULPABLE
// INJURY TO LIFE, BODY OR HEALTH, IN CASE OF INTENTIONAL ACTS, UNDER THE
// LIABILITY PROVISIONS OF THE GERMAN PRODUCT LIABILITY ACT
// (PRODUKTHAFTUNGSGESETZ) OR IN CASE OF A CONTRACTUALLY AGREED OBLIGATION TO
// ASSUME LIABILITY IRRESPECTIVE OF ANY FAULT (GUARANTEE).
//
// IN THE EVENT OF A CONFLICT BETWEEN THE PROVISIONS OF THIS AGREEMENT AND
// ANOTHER AGREEMENT REGARDING THE SOURCE CODE (EXCEPT THE GENERAL TERMS AND
// CONDITIONS OF CINTERION) THE OTHER AGREEMENT SHALL PREVAIL.
//
// All rights created by patent grant or registration of a utility model or
// design patent are reserved.
//
///////////////////////////////////////////////////////////////////////////////

#include <sstream>
#include "stdafx.h"
#include "SimPage.h"
#include "ConnectionManagerDlg.h"
#include "Resource.h"


BEGIN_MESSAGE_MAP(SimPage, CPropertyPage)
    ON_CBN_SELENDOK (IDC_SIM_ACTION_COMBO,OnSimActionSelect)
    ON_BN_CLICKED(IDC_SIM_SUBMIT_BUTTON,OnSimSubmit)
END_MESSAGE_MAP()

// --------------------------------------------------------------------------
// ctor
// --------------------------------------------------------------------------
SimPage::SimPage() : 
    CPropertyPage(IDD_SIM_PAGE),
    m_pCMDlg(NULL)
{
    m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button
}

// --------------------------------------------------------------------------
// SetCMDlg
// --------------------------------------------------------------------------
void SimPage::SetCMDlg(ConnectionManagerDlg* pCMDlg)
{
    m_pCMDlg = pCMDlg;
}

// --------------------------------------------------------------------------
// DoDataExchange
// --------------------------------------------------------------------------
void SimPage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_PIN1_GROUP, m_pin1Group);
    DDX_Control(pDX, IDC_PIN1_STATUS_STATIC, m_pin1StatusStatic);
    DDX_Control(pDX, IDC_PIN1_VERIFY_RETRIES_LEFT_STATIC, m_pin1VerifyRetriesLeftStatic);
    DDX_Control(pDX, IDC_PIN1_UNBLOCK_RETRIES_LEFT_STATIC, m_pin1UnblockRetriesLeftStatic);
    DDX_Control(pDX, IDC_PIN2_GROUP, m_pin2Group);
    DDX_Control(pDX, IDC_PIN2_STATUS_STATIC, m_pin2StatusStatic);
    DDX_Control(pDX, IDC_PIN2_VERIFY_RETRIES_LEFT_STATIC, m_pin2VerifyRetriesLeftStatic);
    DDX_Control(pDX, IDC_PIN2_UNBLOCK_RETRIES_LEFT_STATIC, m_pin2UnblockRetriesLeftStatic);
    DDX_Control(pDX, IDC_SIM_ACTIONS_GROUP, m_simActionsGroup);
    DDX_Control(pDX, IDC_SIM_ACTION_STATIC, m_simActionStatic);
    DDX_Control(pDX, IDC_SIM_ACTION_COMBO, m_simActonCombo);
    DDX_Control(pDX, IDC_PIN_ID_STATIC, m_pinIdStatic);
    DDX_Control(pDX, IDC_PIN_ID_COMBO, m_pinIdCombo);
    DDX_Control(pDX, IDC_SIM_FIELD1_STATIC, m_simField1Static);
    DDX_Control(pDX, IDC_SIM_FIELD1_EDIT, m_simField1Edit);
    DDX_Control(pDX, IDC_SIM_FIELD1_COMBO, m_simField1Combo);
    DDX_Control(pDX, IDC_SIM_FIELD2_STATIC, m_simField2Static);
    DDX_Control(pDX, IDC_SIM_FIELD2_EDIT, m_simField2Edit);
    DDX_Control(pDX, IDC_SIM_SUBMIT_BUTTON, m_simSubmitButton);
}

// --------------------------------------------------------------------------
// OnInitDialog
// --------------------------------------------------------------------------
BOOL SimPage::OnInitDialog()
{
    CPropertyPage::OnInitDialog();
    
    DisableSelectedState();

    // add predefined values to the sim action combo box
    m_simActonCombo.AddString(_T("Set Pin Protection"));
    m_simActonCombo.AddString(_T("Verify Pin"));
    m_simActonCombo.SetCurSel(0);
    OnSimActionSelect();

    // add predefined values to the pin id combo box
    m_pinIdCombo.AddString(_T("PIN1"));
    m_pinIdCombo.AddString(_T("PIN2"));
    m_pinIdCombo.SetCurSel(0);

    // add predefined values to the sim field 1 combo box
    m_simField1Combo.AddString(_T("Disable Pin"));
    m_simField1Combo.AddString(_T("Enable Pin"));
    m_simField1Combo.SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// --------------------------------------------------------------------------
// EnableSelectedState
//
/// Show availabe fields and send requests to populate them.
// --------------------------------------------------------------------------
void SimPage::EnableSelectedState()
{
    // enable/disable appropriate fields
    m_pin1Group.EnableWindow(TRUE);
    m_pin1StatusStatic.EnableWindow(TRUE);
    m_pin1VerifyRetriesLeftStatic.EnableWindow(TRUE);
    m_pin1UnblockRetriesLeftStatic.EnableWindow(TRUE);
    m_pin2Group.EnableWindow(TRUE);
    m_pin2StatusStatic.EnableWindow(TRUE);
    m_pin2VerifyRetriesLeftStatic.EnableWindow(TRUE);
    m_pin2UnblockRetriesLeftStatic.EnableWindow(TRUE);
    m_simActionsGroup.EnableWindow(TRUE);
    m_simActionStatic.EnableWindow(TRUE);
    m_simActonCombo.EnableWindow(TRUE);
    m_pinIdStatic.EnableWindow(TRUE);
    m_pinIdCombo.EnableWindow(TRUE);
    m_simField1Static.EnableWindow(TRUE);
    m_simField1Edit.EnableWindow(TRUE);
    m_simField1Combo.EnableWindow(TRUE);
    m_simField2Static.EnableWindow(TRUE);
    m_simField2Edit.EnableWindow(TRUE);
    m_simSubmitButton.EnableWindow(TRUE);

    // send get pin status request
    CReqGetPinStatus GetPinStatusMsg;
    GetPinStatusMsg.SendRequest();
}

// --------------------------------------------------------------------------
// DisableSelectedState
//
/// Dim fields that should not be accessed.
// --------------------------------------------------------------------------
void SimPage::DisableSelectedState()
{
    // enable/disable appropriate fields
    m_pin1Group.EnableWindow(FALSE);
    m_pin1StatusStatic.EnableWindow(FALSE);
    m_pin1VerifyRetriesLeftStatic.EnableWindow(FALSE);
    m_pin1UnblockRetriesLeftStatic.EnableWindow(FALSE);
    m_pin2Group.EnableWindow(FALSE);
    m_pin2StatusStatic.EnableWindow(FALSE);
    m_pin2VerifyRetriesLeftStatic.EnableWindow(FALSE);
    m_pin2UnblockRetriesLeftStatic.EnableWindow(FALSE);
    m_simActionsGroup.EnableWindow(FALSE);
    m_simActionStatic.EnableWindow(FALSE);
    m_simActonCombo.EnableWindow(FALSE);
    m_pinIdStatic.EnableWindow(FALSE);
    m_pinIdCombo.EnableWindow(FALSE);
    m_simField1Static.EnableWindow(FALSE);
    m_simField1Edit.EnableWindow(FALSE);
    m_simField1Combo.EnableWindow(FALSE);
    m_simField2Static.EnableWindow(FALSE);
    m_simField2Edit.EnableWindow(FALSE);
    m_simSubmitButton.EnableWindow(FALSE);
}

// --------------------------------------------------------------------------
// BuildReqSetPinProtection
//
// --------------------------------------------------------------------------
void SimPage::BuildReqSetPinProtection(CReqSetPinProtection &msg)
{
    // get pin value
    CString pinValue;
    m_simField2Edit.GetWindowText(pinValue);
    msg.SetPinValue(pinValue);

    msg.SetProtectionSetting(m_simField1Combo.GetCurSel());

    msg.SetPinId(m_pinIdCombo.GetCurSel() + 1);


    return;
}

// --------------------------------------------------------------------------
// BuildReqVerifyPin
//
// --------------------------------------------------------------------------
void SimPage::BuildReqVerifyPin(CReqVerifyPin &msg)
{
    // get pin value
    CString pinValue;
    m_simField1Edit.GetWindowText(pinValue);
    msg.SetPinValue(pinValue);

    msg.SetPinId(m_pinIdCombo.GetCurSel() + 1);

    return;
}

// --------------------------------------------------------------------------
// ProcessGetPinStatusRsp
//
// Actions to take when a ProcessGetPinStatusRsp message is received.
//
// @params pMsg - message pointer to process.
// --------------------------------------------------------------------------
void SimPage::ProcessGetPinStatusRsp(CGetPinStatusRsp *pMsg)
{
    if (pMsg->IsPin1Status())
    {
        DisplayPin1Status(pMsg->GetPin1Status(),
            pMsg->GetPin1VerifyRetriesLeft(),
            pMsg->GetPin1UnblockRetriesLeft());
    }

    if (pMsg->IsPin2Status())
    {
        DisplayPin2Status(pMsg->GetPin2Status(),
            pMsg->GetPin2VerifyRetriesLeft(),
            pMsg->GetPin2UnblockRetriesLeft());
    }
}


// --------------------------------------------------------------------------
// DisplayPin1Status
//
/// Display the pin 1 status information on the sim page.
///
/// @params status - numeric value indicating pin status.
///
/// @params verify - number of verify retries left.
///
/// @params unblock - number of unblock retries left.
// --------------------------------------------------------------------------
void SimPage::DisplayPin1Status(BYTE status, BYTE verify, BYTE unblock)
{
    // display pin1 info
    std::stringstream stream;
    if (status < 5)
    {
        stream << _T("Status: ") << CMDAPI_PIN_STATUS_STRINGS[status];
        m_pin1StatusStatic.SetWindowText(stream.str().c_str());
    }

    stream.str("");
    stream << _T("Verify Retries Left: ") << (UINT)verify;
    m_pin1VerifyRetriesLeftStatic.SetWindowText(stream.str().c_str());

    stream.str("");
    stream << _T("Unblock Retries Left: ") << (UINT)unblock;
    m_pin1UnblockRetriesLeftStatic.SetWindowText(stream.str().c_str());
}


// --------------------------------------------------------------------------
// DisplayPin2Status
//
/// Display the pin 2 status information on the sim page.
///
/// @params status - numeric value indicating pin status.
///
/// @params verify - number of verify retries left.
///
/// @params unblock - number of unblock retries left.
// --------------------------------------------------------------------------
void SimPage::DisplayPin2Status(BYTE status, BYTE verify, BYTE unblock)
{
    // display pin2 info
    std::stringstream stream;
    if (status < 5)
    {
        stream << _T("Status: ") << CMDAPI_PIN_STATUS_STRINGS[status];
        m_pin2StatusStatic.SetWindowText(stream.str().c_str());
    }

    stream.str("");
    stream << _T("Verify Retries Left: ") << (UINT)verify;
    m_pin2VerifyRetriesLeftStatic.SetWindowText(stream.str().c_str());

    stream.str("");
    stream << _T("Unblock Retries Left: ") << (UINT)unblock;
    m_pin2UnblockRetriesLeftStatic.SetWindowText(stream.str().c_str());
}

// --------------------------------------------------------------------------
// OnSimActionSelect
//
/// Actions to take when when a sim action combo box selection is made.
// --------------------------------------------------------------------------
void SimPage::OnSimActionSelect()
{
    switch (m_simActonCombo.GetCurSel())
    {
        case 0:
            m_simField1Edit.ShowWindow(SW_HIDE);
            m_simField1Combo.ShowWindow(SW_SHOW);
            m_simField2Static.ShowWindow(SW_SHOW);
            m_simField2Edit.ShowWindow(SW_SHOW);
            m_simField1Static.SetWindowText(_T("Protection:"));
            m_simField2Static.SetWindowText(_T("Pin Value:"));
            break;
        case 1:
            m_simField1Edit.ShowWindow(SW_SHOW);
            m_simField1Combo.ShowWindow(SW_HIDE);
            m_simField2Static.ShowWindow(SW_HIDE);
            m_simField2Edit.ShowWindow(SW_HIDE);
            m_simField1Static.SetWindowText(_T("Pin Value:"));
            break;
    }
}

// --------------------------------------------------------------------------
// OnSimSubmit
//
/// Actions to take when when the submit button is pressed.
// --------------------------------------------------------------------------
void SimPage::OnSimSubmit()
{
    switch (m_simActonCombo.GetCurSel())
    {
        case 0:
            // send set pin protection request
            {
                CReqSetPinProtection msg;
                BuildReqSetPinProtection(msg);
                msg.SendRequest();
            }
            break;
        case 1:
            // send verify pin request
            {
                CReqVerifyPin msg;
                BuildReqVerifyPin(msg);
                msg.SendRequest();
            }
            break;
    }
    // send get pin status request - update status, retries left
    Sleep(1000);
    CReqGetPinStatus GetPinStatusMsg;
    GetPinStatusMsg.SendRequest();
}
